<template>
  <div :id="id" class="modal fade" tabindex="-1" :aria-labelledby="id + 'hcdCustomModalLabel'" aria-hidden="true">
    <div class="modal-dialog" :class="[fullscreen, size, verticalCenteredComputed, scrollableComputed]">
      <div class="modal-content">
        <div class="modal-header">
          <h1 class="modal-title fs-5" :id="id + 'hcdCustomModalLabel'">{{ props.title }}</h1>
          <button type="button" class="btn-close" @click="hide()" aria-label="Cerrar"></button>
        </div>
        <div class="modal-body">
          <slot v-if="isShowing"></slot>
        </div>
        <!--
        <div class="modal-footer">
          <slot name="footer"></slot>
          <button type="button" class="btn btn-secondary" @click="hide()">Cerrar</button>
        </div>
      -->
        <div class="modal-footer" v-if="$slots.footer">
          <slot name="footer"></slot>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import Modal from 'bootstrap/js/dist/modal';
import { onMounted, onBeforeMount, ref, onUnmounted, nextTick, computed } from 'vue';

const props = defineProps({
  // Options Props
  title: {
    type: String,
    default: "Título del modal",
    required: false
  },
  backdrop: {
    type: Boolean,
    default: true,
    required: false
  },
  focus: {
    type: Boolean,
    default: true,
    required: false
  },
  keyboard: {
    type: Boolean,
    default: true,
    required: false
  },
  // CSS PROPS
  fullscreen: {
    type: String,
    default: "",
    required: false,
    validator: (propValue: string) => {
      let valid = true;
      propValue = propValue.trim().toLocaleLowerCase();
      if (propValue != "") {
        switch (propValue) {
          case "always":
            valid = true;
            break;
          case "sm":
            valid = true;
            break;
          case "md":
            valid = true;
            break;
          case "lg":
            valid = true;
            break;
          case "xl":
            valid = true;
            break;
          case "xxl":
            valid = true;
            break;
          default:
            valid = false;
            break;
        }
      }
      return valid;
    }
  },
  size: {
    type: String,
    default: "",
    required: false,
    validator: (propValue: string) => {
      let valid = true;
      propValue = propValue.trim().toLocaleLowerCase();
      if (propValue != "") {
        switch (propValue) {
          case "sm":
            valid = true;
            break;
          case "lg":
            valid = true;
            break;
          case "xl":
            valid = true;
            break;
          default:
            valid = false;
            break;
        }
      }
      return valid;
    }
  },
  verticalCentered: {
    type: Boolean,
    default: false,
    required: false
  },
  scrollable: {
    type: Boolean,
    default: false,
    required: false
  },
});

const emit = defineEmits(['hide', 'hidden', 'hidePrevented', 'show', 'shown']);
const isShowing = ref(false);
const modal = ref<Modal | null>(null);
const id = ref<string>();
const fullscreen = computed(() => {
  let rta = ""
  switch (props.fullscreen.trim().toLocaleLowerCase()) {
    case "always":
      rta = "modal-fullscreen";
      break;
    case "sm":
      rta = "modal-fullscreen-sm-down";
      break;
    case "md":
      rta = "modal-fullscreen-md-down";
      break;
    case "lg":
      rta = "modal-fullscreen-lg-down";
      break;
    case "xl":
      rta = "modal-fullscreen-xl-down";
      break;
    case "xxl":
      rta = "modal-fullscreen-xxl-down";
      break;
  }
  return rta;
});
const size = computed(() => {
  let rta = ""
  switch (props.size.trim().toLocaleLowerCase()) {
    case "sm":
      rta = "modal-sm";
      break;
    case "lg":
      rta = "modal-lg";
      break;
    case "xl":
      rta = "modal-xl";
      break;
  }
  return rta;
});
const verticalCenteredComputed = computed<string>(() => {
  return (props.verticalCentered) ? "modal-dialog-centered" : "";
});
const scrollableComputed = computed<string>(() => {
  return (props.scrollable) ? "modal-dialog-scrollable" : "";
});

onBeforeMount(() => {
  id.value = "a" + Math.random().toString(36).split(".")[1];
});

onMounted(() => {

  modal.value = new Modal('#' + id.value, {
    backdrop: props.backdrop,
    focus: props.focus,
    keyboard: props.keyboard,
  });

  if (id.value != undefined) {
    document.getElementById(id.value)!.addEventListener('hide.bs.modal', event => {
      emit('hide', event);
    });
    document.getElementById(id.value)!.addEventListener('hidden.bs.modal', event => {
      hide();
      emit('hidden', event);
    });
    document.getElementById(id.value)!.addEventListener('hidePrevented.bs.modal	', event => {
      emit('hidePrevented', event);
    });
    document.getElementById(id.value)!.addEventListener('show.bs.modal', event => {
      emit('show', event);
    });
    document.getElementById(id.value)!.addEventListener('shown.bs.modal', event => {
      emit('shown', event);
    });
  }

});

onUnmounted(() => {
  dispose();
});

//#region METHODS
function dispose() {
  hide();
  modal.value!.dispose();
}

async function show() {
  isShowing.value = true;
  await nextTick();
  modal.value!.show();
}

function hide() {
  modal.value!.hide();
  isShowing.value = false;
}

function handleUpdate() {
  modal.value!.handleUpdate();
}


//#endregion

defineExpose({
  dispose,
  show,
  hide,
  handleUpdate
});
</script>

<style scoped></style>